package $package;

import javax.jws.WebService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.ow2.weblab.core.model.Query;
import org.ow2.weblab.core.services.AccessDeniedException;
import org.ow2.weblab.core.services.ContentNotAvailableException;
import org.ow2.weblab.core.services.InsufficientResourcesException;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.Searcher;
import org.ow2.weblab.core.services.ServiceNotConfiguredException;
import org.ow2.weblab.core.services.UnexpectedException;
import org.ow2.weblab.core.services.UnsupportedRequestException;
import org.ow2.weblab.core.services.searcher.SearchArgs;
import org.ow2.weblab.core.services.searcher.SearchReturn;

/**
 * Template for WebLab service which uses Searcher interface
 * 
 * @author WebLab Team
 */
@WebService(endpointInterface = "org.ow2.weblab.core.services.Searcher")
public class $className implements Searcher {


	/**
	 * The instance of logger used inside $className
	 */
	private final Log logger;


	/**
	 * Constructor
	 */
	public $className() {
		this.logger = LogFactory.getLog(this.getClass());

		// TODO Initialise other fields if needed

		this.logger.info("Service $className successfully started");
	}


	@Override
	public SearchReturn search(final SearchArgs args) throws AccessDeniedException, ContentNotAvailableException, InsufficientResourcesException,
			InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of search method.");

		final Query query = this.checkSearchArgs(args);

		this.logger.info("Start processing query " + query.getUri() + ".");

		// TODO Implement your method here!

		this.logger.error("Method search not yet implemented.");
		throw new UnsupportedRequestException("Method process not yet implemented.");
	}


	/**
	 * Method that tests that the SearchArgs is correct regarding specification
	 * of $className
	 * 
	 * @param args
	 *            The query received by the search method
	 * @return The query inside <code>args</code>
	 * @throws InvalidParameterException
	 *             If args or the query it contains is <code>null</code> or
	 *             offset is less than <code>0</code>
	 */
	protected Query checkSearchArgs(final SearchArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("SearchArgs is null.");
		}
		final Query query = args.getQuery();
		if (query == null) {
			throw new InvalidParameterException("Resource in SearchArgs is null.");
		}
		if (args.getOffset() == null) {
			this.logger.warn("Offset is null zero will be used.");
		} else if (args.getOffset().intValue() < 0) {
			throw new InvalidParameterException("Offset in SearchArgs is less than zero.");
		}

		// TODO Maybe implement a better test for your query(for instance,
		// check that the query is of a type that you can handle?)
		// TODO Test the existence of an usageContext if required

		return query;
	}

}
